//
//  TestFileViewController.swift
//  JKSwiftExtension_Example
//
//  Created by IronMan on 2020/11/25.
//  Copyright © 2020 CocoaPods. All rights reserved.
//

import UIKit

class TestFileViewController: BaseViewController {
    
    override func viewDidLoad() {
        super.viewDidLoad()
        
        self.title = "TestFile"
        self.tableView.backgroundColor = JKDarkModeUtil.colorLightDark(light: .yellow, dark: .green)
        
        let uuid = UIDevice.current.identifierForVendor!.uuidString as NSString
        print("uuid：\(uuid)")
        
        headDataArray = ["一、基本的使用"]
        dataArray = [["设置有内边距的label", "设置有内边距的label", "设置有内边距的label", "设置有内边距的label", "引导页", "设置有内边距的label", "设置有内边距的label", "设置有内边距的label", "设置有内边距的label"]]
    }
}

extension TestFileViewController {
    
    @objc func test15() {
        let vc = FBGuidePageVC()
        vc.modalPresentationStyle = .fullScreen
        self.navigationController?.present(vc, animated: true, completion: nil)
    }
    
    @objc func test14() {
        print("\(2989)".tradeAmountAddCommaString(maximumFractionDigits: 2, minimumFractionDigits: 2, roundingModel: .up))
        print(("\(2989)".tradeAmountAddCommaString(maximumFractionDigits: 2, minimumFractionDigits: 2, roundingModel: .up) as NSString).doubleValue)
        print("\(10)".tradeAmountAddCommaString(maximumFractionDigits: 2, minimumFractionDigits: 2, roundingModel: .up) .jk.toDouble() ?? 0.0)
    }
    
    @objc func test13() {
        self.navigationController?.pushViewController(SixViewController(), animated: true)
    }
    
    @objc func test12() {
        self.navigationController?.pushViewController(TenViewController(), animated: true)
    }
    
    @objc func test11() {
        
    }
}

extension String {
    // 添加千分位，小数点后面保留三位，默认四舍五入
    func tradeAmountAddCommaString(maximumFractionDigits: Int = 2, minimumFractionDigits: Int = 2, roundingModel: NumberFormatter.RoundingMode = .up, numberStyle: NumberFormatter.Style = .none) -> String {
        let formatter = NumberFormatter()
        formatter.numberStyle = .decimal
        formatter.roundingMode = roundingModel
        formatter.maximumFractionDigits = maximumFractionDigits
        formatter.minimumFractionDigits = minimumFractionDigits
        if self.contains(".") {
            // 整数位最少位数
            formatter.minimumIntegerDigits = 1
        }
        var num = NSDecimalNumber(string: self)
        if num.doubleValue.isNaN {
            num = NSDecimalNumber(string: "0")
        }
        if let result = formatter.string(from: num) {
            return result
        }
        return self
    }
  
}



